1011. Capacity To Ship Packages Within D Days**

1011. Capacity To Ship Packages Within D Days**

https://leetcode.com/problems/capacity-to-ship-packages-within-d-days/

题目描述

A conveyor belt has packages that must be shipped from one port to another within D days.

The i-th package on the conveyor belt has a weight of weights[i]. Each day, we load the ship with packages on the conveyor belt (in the order given by weights). We may not load more weight than the maximum weight capacity of the ship.

Return the least weight capacity of the ship that will result in all the packages on the conveyor belt being shipped within D days.

Example 1:

Input: weights = [1,2,3,4,5,6,7,8,9,10], D = 5
Output: 15
Explanation: 
A ship capacity of 15 is the minimum to ship all the packages in 5 days like this:
1st day: 1, 2, 3, 4, 5
2nd day: 6, 7
3rd day: 8
4th day: 9
5th day: 10

Note that the cargo must be shipped in the order given, so using a ship of capacity 14 and splitting the packages into parts like (2, 3, 4, 5), (1, 6, 7), (8), (9), (10) is not allowed. 

Example 2:

Input: weights = [3,2,2,4,1,4], D = 3
Output: 6
Explanation: 
A ship capacity of 6 is the minimum to ship all the packages in 3 days like this:
1st day: 3, 2
2nd day: 2, 4
3rd day: 1, 4

Example 3:

Input: weights = [1,2,3,1,1], D = 4
Output: 3
Explanation: 
1st day: 1
2nd day: 2
3rd day: 3
4th day: 1, 1

Note:

  • 1 <= D <= weights.length <= 50000
  • 1 <= weights[i] <= 500

C++ 实现 1

本题思想有了, 但不成熟, 最后通过阅读 [Java/C++/Python] Binary Search 求解.

在这里插入图片描述

需要注意的是, days 初始化值需要是 1, 这是因为: if (part_weights + weights[i] > capacity) 这个判断语句其实隐含的含义是 part_weights 当前是小于或等于 capacity 的, 就像上面的 1 + 2 + 3 + 4 <= 10, 现在要判断加上了 weights[i] = 5 是否会超过 capacity, 就算不会超过, 那也要一天将货物运完, 故 days 初始值设置为 1.

Binary Search 找到第一个小于或等于的 Ddays. 注意要对 left 初始值约束为货物中的最大值. 如果没有这个约束, 代码会不正确. 原因在于, 比如 left 如果初始化为 0 的话, 可能搜索到的 capacity 比较小, 这样会用更多的 days 来运送货物, 但是 capacity 怎么能小于 weights 中的最大值呢?

class Solution {
public:
    int shipWithinDays(vector<int>& weights, int D) {
        int left = 0, right = 0;
        for (auto &w : weights) {
            right += w;
            left = std::max(left, w); // 要限定船的重量至少是 weights 中的最大值
        }
        int res = right;
        while (left <= right) {
            int capacity = left + (right - left) / 2;
            int part_weights = 0;
            int days = 1;
            for (int i = 0; i < weights.size(); ++ i) {
                if (part_weights + weights[i] > capacity) {
                    days += 1;
                    part_weights = 0;
                }
                part_weights += weights[i];
            }
            if (days > D) left = capacity + 1; // 倘若花费的时间太多, 应该增加容量
            else right = capacity - 1; // 否则减少容量
        }
        return left;
    }
};
发布了227 篇原创文章 · 获赞 6 · 访问量 1万+

猜你喜欢

转载自blog.csdn.net/Eric_1993/article/details/103950952